=== modified file 'DoPlugins.mds'
--- DoPlugins.mds	2009-03-29 17:55:48 +0000
+++ DoPlugins.mds	2009-05-05 19:29:20 +0000
@@ -1,4 +1,5 @@
-<Combine fileversion="2.0" outputpath="build/bin/" name="DoPlugins" releaseversion="0.4.9.9">
+<Combine name="DoPlugins" fileversion="2.0" outputpath="build/bin/" releaseversion="0.4.9.9">
+  <Policies />
   <Configurations active="Debug">
     <Configuration name="Debug" ctype="CombineConfiguration">
       <Entry build="True" name="Rhythmbox" configuration="Debug" />
@@ -71,6 +72,7 @@
       <Entry build="True" name="Tracker" configuration="Debug" />
       <Entry build="True" name="YouTube" configuration="Debug" />
       <Entry build="True" name="Emesene" configuration="Debug" />
+      <Entry build="True" name="RemindMe" configuration="Debug" />
     </Configuration>
     <Configuration name="Release" ctype="CombineConfiguration">
       <Entry build="True" name="Rhythmbox" configuration="Release" />
@@ -143,6 +145,7 @@
       <Entry build="True" name="Tracker" configuration="Release" />
       <Entry build="True" name="YouTube" configuration="Release" />
       <Entry build="True" name="Emesene" configuration="Release" />
+      <Entry build="True" name="RemindMe" configuration="Release" />
     </Configuration>
   </Configurations>
   <StartMode startupentry="Rhythmbox" single="True">
@@ -216,6 +219,7 @@
     <Execute type="None" entry="Tracker" />
     <Execute type="None" entry="YouTube" />
     <Execute type="None" entry="Emesene" />
+    <Execute type="None" entry="RemindMe" />
   </StartMode>
   <MonoDevelop.ChangeLogAddIn.ChangeLogInfo policy="UpdateNearestChangeLog" />
   <Entries>
@@ -289,5 +293,6 @@
     <Entry filename="Tracker/Tracker.mdp" />
     <Entry filename="YouTube/YouTube.mdp" />
     <Entry filename="Emesene/Emesene.mdp" />
+    <Entry filename="RemindMe/RemindMe.mdp" />
   </Entries>
 </Combine>
\ No newline at end of file

=== modified file 'Flickr/gtk-gui/objects.xml'
--- Flickr/gtk-gui/objects.xml	2009-04-23 21:37:32 +0000
+++ Flickr/gtk-gui/objects.xml	2009-05-05 19:29:20 +0000
@@ -1,2 +1,6 @@
 <objects attr-sync="on">
+  <object type="Flickr.UploadConfig" palette-category="Flickr" allow-children="false" base-type="Gtk.Bin">
+    <itemgroups />
+    <signals />
+  </object>
 </objects>
\ No newline at end of file

=== modified file 'Flickr/src/UploadDialog.cs'
--- Flickr/src/UploadDialog.cs	2009-04-24 00:44:55 +0000
+++ Flickr/src/UploadDialog.cs	2009-05-05 19:29:20 +0000
@@ -3,7 +3,6 @@
 
 using Gtk;
 using Gdk;
-using GLib;
 
 using Do.Platform;
 

=== modified file 'Makefile.am'
--- Makefile.am	2009-03-31 22:19:30 +0000
+++ Makefile.am	2009-05-05 19:29:20 +0000
@@ -47,6 +47,7 @@
 	Putty \
 	Quote \
 	RememberTheMilk \
+	RemindMe \
 	RequestTracker \
 	Rhythmbox \
 	Riptide \

=== added directory 'RemindMe'
=== added file 'RemindMe/Makefile.am'
--- RemindMe/Makefile.am	1970-01-01 00:00:00 +0000
+++ RemindMe/Makefile.am	2009-05-05 19:29:20 +0000
@@ -0,0 +1,21 @@
+include $(top_srcdir)/build.rules.mk
+
+ASSEMBLY=RemindMe
+
+FILES = \
+	src/Reminder.cs \
+	src/RemindMe.cs \
+	src/SnoozeableReminder.cs \
+	src/StringExtensions.cs
+
+RESOURCES = \
+	Resources/RemindMe.addin.xml
+
+REFERENCES = \
+	Mono.Posix \
+	System \
+	System.Core \
+	$(GTK_SHARP_20_LIBS) \
+	$(DO_PLATFORM_LIBS) \
+	$(DO_PLATFORM_LINUX_LIBS) \
+	$(DO_UNIVERSE_LIBS)

=== added file 'RemindMe/RemindMe.mdp'
--- RemindMe/RemindMe.mdp	1970-01-01 00:00:00 +0000
+++ RemindMe/RemindMe.mdp	2009-05-05 19:29:20 +0000
@@ -0,0 +1,34 @@
+<Project name="RemindMe" fileversion="2.0" language="C#" targetFramework="3.5" ctype="DotNetProject">
+  <Configurations active="Debug">
+    <Configuration name="Debug" ctype="DotNetProjectConfiguration">
+      <Output directory="bin/Debug" assembly="RemindMe" />
+      <Build debugmode="True" target="Library" />
+      <Execution runwithwarnings="True" consolepause="False" runtime="MsNet" />
+      <CodeGeneration compiler="Mcs" warninglevel="4" optimize="False" unsafecodeallowed="False" generateoverflowchecks="False" definesymbols="DEBUG" generatexmldocumentation="False" ctype="CSharpCompilerParameters" />
+    </Configuration>
+    <Configuration name="Release" ctype="DotNetProjectConfiguration">
+      <Output directory="bin/Release" assembly="RemindMe" />
+      <Build debugmode="False" target="Library" />
+      <Execution runwithwarnings="True" consolepause="False" runtime="MsNet" />
+      <CodeGeneration compiler="Mcs" warninglevel="4" optimize="False" unsafecodeallowed="False" generateoverflowchecks="False" generatexmldocumentation="False" ctype="CSharpCompilerParameters" />
+    </Configuration>
+  </Configurations>
+  <Contents>
+    <File name="src" subtype="Directory" buildaction="Compile" />
+    <File name="src/RemindMe.cs" subtype="Code" buildaction="Compile" />
+    <File name="Resources" subtype="Directory" buildaction="Compile" />
+    <File name="Resources/RemindMe.addin.xml" subtype="Code" buildaction="EmbedAsResource" />
+    <File name="src/StringExtensions.cs" subtype="Code" buildaction="Compile" />
+    <File name="src/SnoozeableReminder.cs" subtype="Code" buildaction="Compile" />
+    <File name="src/Reminder.cs" subtype="Code" buildaction="Compile" />
+  </Contents>
+  <References>
+    <ProjectReference type="Gac" localcopy="True" refto="System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" />
+    <ProjectReference type="Gac" localcopy="True" refto="glib-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
+    <ProjectReference type="Assembly" localcopy="True" specificVersion="False" refto="../../../../../../usr/local/lib/gnome-do/Do.Platform.dll" />
+    <ProjectReference type="Assembly" localcopy="True" specificVersion="False" refto="../../../../../../usr/local/lib/gnome-do/Do.Platform.Linux.dll" />
+    <ProjectReference type="Assembly" localcopy="True" specificVersion="False" refto="../../../../../../usr/local/lib/gnome-do/Do.Universe.dll" />
+    <ProjectReference type="Gac" localcopy="True" refto="Mono.Posix, Version=2.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756" />
+    <ProjectReference type="Gac" localcopy="True" refto="System.Core, Version=3.5.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" />
+  </References>
+</Project>
\ No newline at end of file

=== added directory 'RemindMe/Resources'
=== added file 'RemindMe/Resources/RemindMe.addin.xml'
--- RemindMe/Resources/RemindMe.addin.xml	1970-01-01 00:00:00 +0000
+++ RemindMe/Resources/RemindMe.addin.xml	2009-05-05 19:29:20 +0000
@@ -0,0 +1,25 @@
+<Addin
+	id="RemindMe"
+	namespace= "Do"
+	version="1.0"
+	name="Remind Me"
+	description="Make small reminders."
+	author="Chris Szikszoy"
+	category="Community"
+	defaultEnabled="false"
+>
+
+	<Runtime>
+		<Import assembly="RemindMe.dll"/>
+	</Runtime>
+
+	<Dependencies>
+		<Addin id="Universe" version="1.0" />
+	</Dependencies>
+
+	<!-- Extensions included in this assembly -->
+	<Extension path="/Do/Action">
+
+		<Action type="RemindMe.RemindMe" />
+	</Extension>
+</Addin>

=== added directory 'RemindMe/src'
=== added file 'RemindMe/src/RemindMe.cs'
--- RemindMe/src/RemindMe.cs	1970-01-01 00:00:00 +0000
+++ RemindMe/src/RemindMe.cs	2009-05-05 19:29:20 +0000
@@ -0,0 +1,237 @@
+//  RemindMe.cs
+//
+//  GNOME Do is the legal property of its developers.
+//  Please refer to the COPYRIGHT file distributed with this
+//  source distribution.
+//
+//  This program is free software: you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation, either version 3 of the License, or
+//  (at your option) any later version.
+//
+//  This program is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+//
+
+using System;
+using System.Linq;
+using System.Collections.Generic;
+using Mono.Unix;
+
+using GLib;
+
+using Do.Universe;
+using Do.Platform;
+
+namespace RemindMe
+{
+
+	public class RemindMe : Act
+	{
+		
+		readonly string remindMessageHourMin;
+		readonly string remindMessageMin;
+		readonly string [] timeKeyWords;
+		
+		class AllowSnoozeItem : Item
+		{
+			
+			public override string Name {
+				get { return Catalog.GetString ("Allow Snooze"); }
+			}
+			
+			public override string Description {
+				get { return Catalog.GetString ("Allows this reminder to be snoozed."); }
+			}
+			
+			public override string Icon {
+			get { return ""; }
+			}			
+		}
+		
+		class NoSnoozeItem : Item
+		{
+			
+			public override string Name {
+				get { return Catalog.GetString ("No Snooze Allowed"); }
+			}
+			
+			public override string Description {
+				get { return Catalog.GetString ("This reminder cannot be snoozed."); }
+			}
+			
+			public override string Icon {
+			get { return ""; }
+			}			
+		}
+		
+		public RemindMe ()
+		{
+			remindMessageHourMin = Catalog.GetString ("You will be reminded in {0} hours, {0} minutes.");
+			remindMessageMin = Catalog.GetString ("You will be reminded in {0} minutes");
+			timeKeyWords = new string[] {Catalog.GetString ("in"), Catalog.GetString ("at")};
+		}
+
+		public override string Name {
+			get { return Catalog.GetString ("Remind Me"); }
+		}
+
+		public override string Description {
+			get { return Catalog.GetString ("Simple Reminders"); }
+		}
+
+		public override string Icon {
+			get { return ""; }
+		}
+
+		public override IEnumerable<Type> SupportedItemTypes {
+			get {
+				yield return typeof (ITextItem);
+			}
+		}
+
+		public override bool SupportsItem (Item item) {
+			return true;
+		}
+		
+		public override IEnumerable<Type> SupportedModifierItemTypes
+		{
+			get {
+				yield return typeof (AllowSnoozeItem);
+				yield return typeof (NoSnoozeItem);
+			}
+		}
+		
+		public override IEnumerable<Item> DynamicModifierItemsForItem (Item item)
+		{
+			yield return new AllowSnoozeItem ();
+			yield return new NoSnoozeItem ();
+		}
+		
+		public override bool ModifierItemsOptional
+		{
+			get { return true; }
+		}
+
+		public override IEnumerable<Item> Perform (IEnumerable<Item> items, IEnumerable<Item> modItems)
+		{
+			string message, matchedWord;
+			TimeSpan timeout;
+			message = (items.First () as ITextItem).Text;
+			
+			//bad time string, bail
+			if (!message.ContainsAny (timeKeyWords))
+			    yield break;
+			
+			timeout = ParseTimeString (message.Substring (message.LastIndexOfAny (timeKeyWords, out matchedWord) + matchedWord.Length));
+			message = message.Substring (0, message.LastIndexOfAny (timeKeyWords)).Trim ();
+			
+			if (timeout.TotalMilliseconds == 0)
+				yield break;
+			         			
+			MaybeShowMessage (timeout);
+			
+			Notification reminder;
+			
+			if (modItems.Any ())
+			{
+				if (modItems.First () is AllowSnoozeItem)
+					reminder = new SnoozeableReminder (message, timeout);
+				else
+					reminder = new Reminder (message, timeout);
+			}
+			else
+				reminder = new Reminder (message, timeout);
+			
+			GLib.Timeout.Add ((uint) 
+timeout.TotalMilliseconds, () => { 
+				Services.Notifications.Notify (reminder);
+				return false; 
+			});
+			yield break;
+		}
+		
+		TimeSpan ParseTimeString (string timeStr)
+		{
+			DateTime t;
+			TimeSpan notificationTimeout = new TimeSpan (0,0,0);
+			
+			//this will catch strings like 10:00 PM or 14:12
+			if (TryConvert (timeStr, out t)) {
+				notificationTimeout = t-DateTime.Now;
+				return notificationTimeout;
+			}
+			//this will catch strings like 2m2s or 2 h 2 m
+			else /*if (timeStr.ContainsAny (new [] {"h", "m", "s"}))*/ {
+				int hours, minutes, seconds;
+				hours = minutes = seconds = 0;
+				
+				timeStr = timeStr.Replace (" ", null);
+				//I'm not quite sure how to make these translateable...
+				//There could be a case where the first letter for two time units are the same,
+				//for example, german Stunde = hour, Sekund = second.
+				foreach (string match in timeStr.Matches (new [] {"h", "m", "s"})) {
+					try {
+						switch (match) {
+						case "h":
+							hours = GetTimeUnit (timeStr, "h", out timeStr);
+							break;
+						case "m":
+							minutes = GetTimeUnit (timeStr, "m", out timeStr);
+							break;
+						case "s":
+							seconds = GetTimeUnit (timeStr, "s", out timeStr);
+							break;
+						}
+					}
+					//bad time string
+					catch (Exception e) {
+						return new TimeSpan ();
+					}
+				}
+				notificationTimeout = notificationTimeout.Add (
+				    new TimeSpan (hours, minutes, seconds));
+				return notificationTimeout;
+			}
+		}
+		
+		bool TryConvert (string timeString, out DateTime time)
+		{			
+			try {
+				time = Convert.ToDateTime (timeString);
+			}
+			catch {
+				time = default (DateTime);
+				return false;
+			}
+			return true;
+		}
+		
+		void MaybeShowMessage (TimeSpan timeout)
+		{
+			if (timeout.TotalMinutes < 2)
+				return;
+			else if (timeout.TotalMinutes < 60) {
+				Services.Notifications.Notify ("RemindMe", 
+			        string.Format (remindMessageMin, timeout.Minutes));
+			}
+			else {
+				Services.Notifications.Notify ("RemindMe", 
+			        string.Format (remindMessageHourMin, timeout.Hours, timeout.Minutes));
+			}
+			return;
+		}
+		
+		int GetTimeUnit (string input, string match, out string remainingString)
+		{
+			int val = int.Parse (input.Substring (0, input.IndexOf (match)));
+			remainingString = input.Substring (input.IndexOf (match)+1);
+			return val;
+		}
+	}
+}

=== added file 'RemindMe/src/Reminder.cs'
--- RemindMe/src/Reminder.cs	1970-01-01 00:00:00 +0000
+++ RemindMe/src/Reminder.cs	2009-05-05 19:29:20 +0000
@@ -0,0 +1,41 @@
+//  Reminder.cs
+//
+//  GNOME Do is the legal property of its developers.
+//  Please refer to the COPYRIGHT file distributed with this
+//  source distribution.
+//
+//  This program is free software: you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation, either version 3 of the License, or
+//  (at your option) any later version.
+//
+//  This program is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+//
+
+using System;
+
+using GLib;
+
+using Do.Platform;
+namespace RemindMe
+{
+	
+	
+	public class Reminder : Notification
+	{
+		
+		public Reminder(string message, TimeSpan timeout) : base ("RemindMe", message, "")
+		{
+			base.Body = message;
+			this.ReminderDelay = timeout;
+		}
+		
+		TimeSpan ReminderDelay { get; set; }
+	}
+}
\ No newline at end of file

=== added file 'RemindMe/src/SnoozeableReminder.cs'
--- RemindMe/src/SnoozeableReminder.cs	1970-01-01 00:00:00 +0000
+++ RemindMe/src/SnoozeableReminder.cs	2009-05-05 19:29:20 +0000
@@ -0,0 +1,62 @@
+//  SnoozeableReminder.cs
+//
+//  GNOME Do is the legal property of its developers.
+//  Please refer to the COPYRIGHT file distributed with this
+//  source distribution.
+//
+//  This program is free software: you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation, either version 3 of the License, or
+//  (at your option) any later version.
+//
+//  This program is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+//
+
+using System;
+
+using GLib;
+
+using Do.Platform;
+namespace RemindMe
+{
+	
+	
+	public class SnoozeableReminder : ActionableNotification
+	{
+		
+		public SnoozeableReminder(string message, TimeSpan timeout) : base ("RemindMe", message, "", "Snooze")
+		{
+			base.Body = message;
+			this.ReminderDelay = timeout;
+		}
+		
+		TimeSpan ReminderDelay { get; set; }
+		
+		TimeSpan SnoozeTime {
+			get 
+			{
+				//the snooze time is the lesser of (TotalReminderSeconds / 4) and 180 (3 minutes
+				//ie, for all reminders > 12 minutes, the snooze time is still 3 minutes.
+				//however, we still set the floor for a snooze time to be 30 seconds
+				int snoozeTime = (int) Math.Max (Math.Min (ReminderDelay.TotalSeconds / 4, 180), 30);
+				return new TimeSpan (0,0,snoozeTime);
+			}
+		}
+		
+		public override void PerformAction ()
+		{
+			GLib.Timeout.Add ((uint) 
+this.SnoozeTime.TotalMilliseconds, () => {
+				Services.Notifications.Notify (new SnoozeableReminder (this.Body, this.SnoozeTime));
+				return false; 
+			});
+		}
+
+	}
+}

=== added file 'RemindMe/src/StringExtensions.cs'
--- RemindMe/src/StringExtensions.cs	1970-01-01 00:00:00 +0000
+++ RemindMe/src/StringExtensions.cs	2009-05-05 19:29:20 +0000
@@ -0,0 +1,72 @@
+//  StringExtensions.cs
+//
+//  GNOME Do is the legal property of its developers.
+//  Please refer to the COPYRIGHT file distributed with this
+//  source distribution.
+//
+//  This program is free software: you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation, either version 3 of the License, or
+//  (at your option) any later version.
+//
+//  This program is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+//
+
+using System;
+using System.Linq;
+using System.Collections.Generic;
+
+namespace RemindMe
+{
+	
+	public static class StringExtensions
+	{
+		
+		//let's get cute and make playing with these strings more fun
+		public static bool ContainsAny (this string str, IEnumerable<string> items)
+		{
+			foreach (string item in items) {
+				if (str.Contains (item))
+				    return true;
+			}
+			return false;
+		}
+		
+		public static IEnumerable<string> Matches (this string str, IEnumerable<string> items)
+		{
+			foreach (string item in items) {
+				if (str.Contains (item))
+					yield return item;
+			}
+			yield break;
+		}
+		
+		public static int LastIndexOfAny (this string str, IEnumerable<string> items, out string match)
+		{
+			int index = -1;
+			match = "";
+			
+			foreach (string item in items) {
+				if (str.Contains (item)) {
+					if (str.LastIndexOf (item) > index) {
+						index = str.LastIndexOf (item);
+						match = item;
+					}
+				}
+			}
+			return index;
+		}
+		
+		public static int LastIndexOfAny (this string str, IEnumerable<string> items)
+		{
+			string match;
+			return str.LastIndexOfAny (items, out match);
+		}
+	}
+}

=== modified file 'configure.ac'
--- configure.ac	2009-03-20 23:05:29 +0000
+++ configure.ac	2009-05-05 19:29:20 +0000
@@ -164,6 +164,7 @@
 Putty/Makefile
 Quote/Makefile
 RememberTheMilk/Makefile
+RemindMe/Makefile
 Rhythmbox/Makefile
 Riptide/Makefile
 RSS/Makefile

